package com.technology.huahai.web.service.impl;

import com.technology.huahai.common.core.controller.domain.AjaxResult;
import com.technology.huahai.common.exception.CsmException;
import com.technology.huahai.web.dto.LdDto;
import com.technology.huahai.web.dto.RzRzrInfoDto;
import com.technology.huahai.web.dto.RzfDto;
import com.technology.huahai.web.mapper.coremapper.CsmMapper;
import com.technology.huahai.web.service.CsmFormService;
import com.technology.huahai.web.vo.QueryRzfDto;
import com.technology.huahai.web.zx.ZxService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

@Service
public class CsmFormServiceImpl implements CsmFormService {

    protected final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private ZxService zxService;

    @Autowired
    private CsmMapper csmMapper;

    @Override
    public AjaxResult saveRzfInfo(RzfDto rzfDto) {
        AjaxResult ajaxResult = zxService.cmsEmsInterfaceOperation(rzfDto,"saveRzfInfo");
        return ajaxResult;
    }

    @Override
    public AjaxResult queryRzfInfo(QueryRzfDto queryRzfDto) {
        AjaxResult ajaxResult = zxService.cmsEmsInterfaceOperation(queryRzfDto,"saveRzfInfo");
        return ajaxResult;
    }

    @Override
    @Transactional
    public AjaxResult saveRzrInfo(RzRzrInfoDto rzRzrInfoDto) {
        try {
            csmMapper.updateDjcs(rzRzrInfoDto.getSmId());
            AjaxResult ajaxResult = zxService.cmsEmsInterfaceOperation(rzRzrInfoDto,"cjm/saveRzrInfo");
            if(0==ajaxResult.getCode()){
                return ajaxResult;
            }else{
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return ajaxResult;
            }
        }catch (Exception e){
            e.printStackTrace();
            logger.error("保存入住人信息出错: {}",e);
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            throw new CsmException("保存入住人信息出错");
        }
    }

    @Override
    public AjaxResult ld(LdDto ldDto) {
        return zxService.cmsEmsInterfaceOperation(ldDto,"cjm/ld");
    }
}
