package com.technology.huahai.web.system.cache;

import com.technology.huahai.common.constant.RedisKeyConstant;
import com.technology.huahai.common.utils.RedisUtils;
import com.technology.huahai.common.utils.poi.ExcelUtil;
import com.technology.huahai.web.domain.entity.Dict;
import com.technology.huahai.web.mapper.coremapper.DictMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
@Component
public class DictDataCache implements CommandLineRunner {

    private static final Logger log = LoggerFactory.getLogger(DictDataCache.class);
    @Autowired
    private RedisUtils redisUtils;
    @Autowired
    private DictMapper dictMapper;

    @Override
    public void run(String... args) throws Exception {
        log.info("开始加载字典缓存");
        try {
            List<Dict> dicts = dictMapper.loadAll();
            Map<String, List<Dict>> collect = dicts.stream().collect(Collectors.groupingBy(Dict::getDictType));
            collect.forEach((name,list)->{
                list.forEach(x->redisUtils.set(RedisKeyConstant.dictKey+name+"::"+x.getDictKey(),x.getDictValue()));
            });
            log.info("字典缓存加载完成");
        }catch (Exception e){
            e.printStackTrace();
            log.error("字典缓存加载失败 {}",e);
        }

    }
}
